# coding: utf-8

"""
    Mainnet Cash

    A developer friendly bitcoin cash wallet api  This API is currently in *active* development, breaking changes may be made prior to official release of version 1.0.0.   # noqa: E501

    The version of the OpenAPI document: 2.3.6
    Contact: hello@mainnet.cash
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mainnet.configuration import Configuration


class TokenMintRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'wallet_id': 'str',
        'token_id': 'str',
        'requests': 'list[TokenMintRequestRequests]',
        'deduct_token_amount': 'bool'
    }

    attribute_map = {
        'wallet_id': 'walletId',
        'token_id': 'tokenId',
        'requests': 'requests',
        'deduct_token_amount': 'deductTokenAmount'
    }

    def __init__(self, wallet_id=None, token_id=None, requests=None, deduct_token_amount=False, local_vars_configuration=None):  # noqa: E501
        """TokenMintRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._wallet_id = None
        self._token_id = None
        self._requests = None
        self._deduct_token_amount = None
        self.discriminator = None

        self.wallet_id = wallet_id
        self.token_id = token_id
        if requests is not None:
            self.requests = requests
        if deduct_token_amount is not None:
            self.deduct_token_amount = deduct_token_amount

    @property
    def wallet_id(self):
        """Gets the wallet_id of this TokenMintRequest.  # noqa: E501

        The walletId to make a request to.  # noqa: E501

        :return: The wallet_id of this TokenMintRequest.  # noqa: E501
        :rtype: str
        """
        return self._wallet_id

    @wallet_id.setter
    def wallet_id(self, wallet_id):
        """Sets the wallet_id of this TokenMintRequest.

        The walletId to make a request to.  # noqa: E501

        :param wallet_id: The wallet_id of this TokenMintRequest.  # noqa: E501
        :type wallet_id: str
        """
        if self.local_vars_configuration.client_side_validation and wallet_id is None:  # noqa: E501
            raise ValueError("Invalid value for `wallet_id`, must not be `None`")  # noqa: E501

        self._wallet_id = wallet_id

    @property
    def token_id(self):
        """Gets the token_id of this TokenMintRequest.  # noqa: E501

        Token unique hexadecimal identifier, also the id of the token creation transaction  # noqa: E501

        :return: The token_id of this TokenMintRequest.  # noqa: E501
        :rtype: str
        """
        return self._token_id

    @token_id.setter
    def token_id(self, token_id):
        """Sets the token_id of this TokenMintRequest.

        Token unique hexadecimal identifier, also the id of the token creation transaction  # noqa: E501

        :param token_id: The token_id of this TokenMintRequest.  # noqa: E501
        :type token_id: str
        """
        if self.local_vars_configuration.client_side_validation and token_id is None:  # noqa: E501
            raise ValueError("Invalid value for `token_id`, must not be `None`")  # noqa: E501

        self._token_id = token_id

    @property
    def requests(self):
        """Gets the requests of this TokenMintRequest.  # noqa: E501


        :return: The requests of this TokenMintRequest.  # noqa: E501
        :rtype: list[TokenMintRequestRequests]
        """
        return self._requests

    @requests.setter
    def requests(self, requests):
        """Sets the requests of this TokenMintRequest.


        :param requests: The requests of this TokenMintRequest.  # noqa: E501
        :type requests: list[TokenMintRequestRequests]
        """

        self._requests = requests

    @property
    def deduct_token_amount(self):
        """Gets the deduct_token_amount of this TokenMintRequest.  # noqa: E501

        if minting token contains fungible amount, deduct from it by amount of minted tokens  # noqa: E501

        :return: The deduct_token_amount of this TokenMintRequest.  # noqa: E501
        :rtype: bool
        """
        return self._deduct_token_amount

    @deduct_token_amount.setter
    def deduct_token_amount(self, deduct_token_amount):
        """Sets the deduct_token_amount of this TokenMintRequest.

        if minting token contains fungible amount, deduct from it by amount of minted tokens  # noqa: E501

        :param deduct_token_amount: The deduct_token_amount of this TokenMintRequest.  # noqa: E501
        :type deduct_token_amount: bool
        """

        self._deduct_token_amount = deduct_token_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TokenMintRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TokenMintRequest):
            return True

        return self.to_dict() != other.to_dict()
